﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win.Misc;
using System.Drawing;
using System.Diagnostics;

namespace WindowsFormsApplication12
{
    class MyExpandableGroupBox : UltraExpandableGroupBox
    {
        protected override void OnCreateControl()
        {
            base.OnCreateControl();
            this.Panel.MouseMove += new System.Windows.Forms.MouseEventHandler(Panel_MouseMove);
            this.Panel.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(Panel_MouseDoubleClick);
        }

        void Panel_MouseDoubleClick(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            Point mouse = e.Location;
            if (this.Panel.ClientSize.Height - 3 < mouse.Y && mouse.Y < this.Panel.ClientSize.Height + 3)
            {
                this.Panel.Cursor = System.Windows.Forms.Cursors.Default;
                this.Panel.Capture = false;
                this.Expanded = false;

            }
        }

        void Panel_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            Point mouse = e.Location;
            if (this.Panel.Capture == true)
            {
                this.Height = Math.Max(mouse.Y + 20,35);

            }
            else
            {
                if (this.Panel.ClientSize.Height - 3 < mouse.Y && mouse.Y < this.Panel.ClientSize.Height + 3)
                {
                    this.Panel.Cursor = System.Windows.Forms.Cursors.SizeNS;
                }
                else
                {
                    this.Panel.Cursor = System.Windows.Forms.Cursors.Default;
                }
            }
        }

        protected override void OnMouseDown(System.Windows.Forms.MouseEventArgs e)
        {
            base.OnMouseDown(e);
            if (this.Panel.Cursor == System.Windows.Forms.Cursors.SizeNS)
                this.Panel.Capture = true;
        }

        protected override void OnMouseUp(System.Windows.Forms.MouseEventArgs e)
        {
            base.OnMouseUp(e);
            this.Panel.Capture = false;
        }

       

        protected override void OnMouseDoubleClick(System.Windows.Forms.MouseEventArgs e)
        {
            base.OnMouseDoubleClick(e);
           
        }
    }
}
